/* certificates.js - API library for certifacte configurations */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,11OCT10,mvb  written. 
*/


function selfCertInfoValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Please enter a name for the certificate request being generated';
     var errMsgL10n2 ='Please enter a subject for the certificate request being generated';
     var errMsgL10n3 ='Invalid IP address.';
     var errMsgL10n4 ='for octet';
     
     /* L10N Error Message Collection End */    
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtSelfCertName,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtSelfCertSubject,"+ errMsgL10n2;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
   	if (ipv4AddrOctetsValidate ('tblSelfCertIpAddr', 'IPD', true, true,
         errMsgL10n3,errMsgL10n4+" ", true) == false)
	   	return false;
    return true;
    }
function fileUploadCheck (fileId, errMsg)
	{
	var obj = document.getElementById (fileId);
	if (!obj || obj.disabled) return false;
	if (obj.value.length > 0)
		return true;
	if (errMsg)
		alert (errMsg);
	return false;
	}
