function pageValidate ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtPolicyName,Please enter the PolicyName";    

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;   
         
    if (ipaddrValidateCheck() == false)
    	return false;
    	
    txtFieldIdArr[1] = "txtStrPort,Please enter the Port Number between 0-65535";
    txtFieldIdArr[2] = "txtEndPort,Please enter the Port Number between 0-65535";
    txtFieldIdArr[3] = "selDefinedResource,Please add at least one resource to configure policy over Network Resource";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    var maskLenObj = document.getElementById ('txtMaskLen');
    if (numericValueRangeCheck (maskLenObj, '', '', 0, 32, true, '', '') == false)
    	return false
         
    var strPortObj = document.getElementById ('txtStrPort');
    if (numericValueRangeCheck (strPortObj, '', '', 0, 65535, true, '', '') == false)
    	return false

    var endPortObj = document.getElementById ('txtEndPort');
    if (numericValueRangeCheck (endPortObj, '', '', 0, 65535, true, '', '') == false)
    	return false

    if (checkPortRange ('txtStrPort', 'txtEndPort') == false)
    	return false

	return true;
    }
         
function applyPolicyCheck ()      
	{
	var mode = radioCheckedValueGet ('SSLVPNPolicy.DestinationObjectType');
	var radioValue = parseInt(document.getElementById ('selIPType').value,10);
	var editFlag = document.getElementById('hdEditFlag').value;
	switch(parseInt(mode,10))
		{
		case 2:
			if(editFlag == 1)
			    {
			    if(radioValue == 2)
			       {
			        fieldStateChangeWr ('selDefinedResource selService tblWi1IpSnetmask txtPreLenId txtIPAdd','','txtStrPort txtEndPort txtIPAddV6','');
			       }
			    else
			       {
			         fieldStateChangeWr ('selDefinedResource selService tblWi1IpSnetmask txtPreLenId txtIPAddV6','','txtStrPort txtEndPort txtIPAdd','');
			       }
			    selIPAddrType ();
			    }
			else
			    {
			    if(radioValue == 2)
			       {
			        fieldStateChangeWr ('selDefinedResource tblWi1IpSnetmask txtPreLenId txtIPAdd','','selService txtStrPort txtEndPort txtIPAddV6','');
			       }
			    else
			       {
			        fieldStateChangeWr ('selDefinedResource tblWi1IpSnetmask txtPreLenId txtIPAddV6','','selService txtStrPort txtEndPort txtIPAdd','');	
			       }
			    
			    selIPAddrType ();
			    }
   			break;
		case 3:
		    if(editFlag == 1)	    
			    {
			    if(radioValue == 2)
			       {			          
			          fieldStateChangeWr ('selDefinedResource selService txtIPAdd tblWi1IpSnetmask','','txtStrPort txtEndPort txtPreLenId txtIPAddV6','');
                   }
                else
                   {
                      fieldStateChangeWr ('selDefinedResource selService txtPreLenId txtIPAddV6','','txtStrPort txtEndPort txtIPAdd tblWi1IpSnetmask','');
                   }
			    
			    applyPolicyInnerFun ();
			    }
			else
			    {
			    if(radioValue == 2)
			       {			          
			          fieldStateChangeWr ('selDefinedResource txtIPAdd tblWi1IpSnetmask','','selService txtStrPort txtEndPort txtPreLenId txtIPAddV6','');
                   }
                else
                   {
                      fieldStateChangeWr ('selDefinedResource txtIPAdd tblWi1IpSnetmask txtPreLenId txtIPAddV6','','selService txtStrPort txtEndPort txtIPAdd tblWi1IpSnetmask','');
                   }			    
			    applyPolicyInnerFun ();
			    }
			break;
		case 4:
		    if(editFlag == 1)
			    fieldStateChangeWr ('selDefinedResource selService txtPreLenId txtIPAddV6 txtIPAdd tblWi1IpSnetmask ','','txtStrPort txtEndPort','');
			else
			    fieldStateChangeWr ('selDefinedResource txtPreLenId txtIPAddV6 txtIPAdd tblWi1IpSnetmask','','selService txtStrPort txtEndPort','');
			break;
		case 1:
		default:
			fieldStateChangeWr ('selService txtStrPort txtEndPort txtPreLenId txtIPAddV6 txtIPAdd tblWi1IpSnetmask','','selDefinedResource','');
   			break;
		};
	}

function policyTypeCheck ()      
	{
	var mode = radioCheckedValueGet ('SSLVPNPolicy.PolicyType');
	switch(mode)
		{
		case 'group':
			fieldStateChangeWr ('selUser', '', 'selGroup', '');
   			break;
		case 'user':
			fieldStateChangeWr ('selGroup', '', 'selUser', '');
			break;
		case 'global':
		default:
			fieldStateChangeWr ('selGroup selUser', '', '', '');
   			break;
		};
	}
	
function loadPolicySettings ()
    {
    isEditCall ();
    toggleWrapper();
    }

function isEditCall ()
	{
	var editFlagObj = document.getElementById ('hdEditFlag');
	var rdbApplyPolicyToObj = document.getElementById('rdbApplyPolicyTo');
	if(rdbApplyPolicyToObj) 
	    var rdbApplyPolicyTo = parseInt(rdbApplyPolicyToObj.value, 10);
	if (!editFlagObj || isNaN (editFlagObj.value)) return;
	if (parseInt (editFlagObj.value, 10) == 1)
	    {
	    switch(rdbApplyPolicyTo)
	        {
	        case 1:
	            fieldStateChangeWr ('rdbApplyPolicyToIPAdd rdbApplyPolicyToIPAddRange rdbApplyPolicyToAllIPAdd selService', 'tblPolicyFor', 'rdbApplyPolicyToNetworkResource', '');
	            break;
	        case 2:
	            fieldStateChangeWr ('rdbApplyPolicyToNetworkResource rdbApplyPolicyToIPAddRange rdbApplyPolicyToAllIPAdd selService', 'tblPolicyFor', 'rdbApplyPolicyToIPAdd', '');
	            break;
	        case 3:
	            fieldStateChangeWr ('rdbApplyPolicyToNetworkResource rdbApplyPolicyToIPAdd rdbApplyPolicyToAllIPAdd selService', 'tblPolicyFor', 'rdbApplyPolicyToIPAddRange', '');
	            break;
	        case 4:
	            fieldStateChangeWr ('rdbApplyPolicyToNetworkResource rdbApplyPolicyToIPAdd rdbApplyPolicyToIPAddRange selService', 'tblPolicyFor', 'rdbApplyPolicyToAllIPAdd', '');
	            break;
	        }
	    }
	}
function ipAddrCheck()
	{
	var radioVal = radioCheckedValueGet ('SSLVPNPolicy.DestinationObjectType');
	if(radioVal == 3)
	    {
	    if(ipv4Validate ('txtIPAdd', 'SN', false, true, 'Invalid IP address', 'for octet ', true) == false) return false;
	    if (ipv4Validate ('tblWi1IpSnetmask', 'SNM', false, true,'Invalid Subnet Mask', 'for octate ', true) == false) return false;
	    return true;
	    }
	    
	else if (radioVal == 2)
		return ipv4Validate ('txtIPAdd', 'IP', false, true, 'Invalid IP address.', 'for octet', true);
	else
	    return true;
	}
function ipaddrValidateCheck()
    {
    var hdIPmodeObj = document.getElementById('ipModeType');
	var selIPType = document.getElementById('selIPType').value;
    var txtPreLenObj = document.getElementById('txtPreLenId');
    var radioVal = radioCheckedValueGet ('SSLVPNPolicy.DestinationObjectType');
    var flag = 0;    
    var flagInner = 0;
    
    if(hdIPmodeObj && hdIPmodeObj == '') return false;    
    if(radioVal == 3)
        flag = 3;
    else if(radioVal == 2)
        flag = 2;
    else
        flag = 0;

    if(hdIPmodeObj.value != 3) /* Only IPV4 mode*/
        {
        if(flag == 3) /* IPNetwork IPV4 mode*/
            flagInner = 1; /*ipv4 validation */
        else if(flag == 2) /* IPAddress IPV4 mode*/
            flagInner = 2; /*ipv4 validation */
        else
           flagInner = 0; 
        }
     else if(hdIPmodeObj.value == 3) /* both IPV4/IPv6 mode*/
         {
         if(flag == 3) /* IPV4/IPv6 - IP Network */
             {
             if(selIPType == 2) /*IP Version = IPv6 */
                 {
                 flagInner = 3; /*For IP Network = IPv6 validation */
                 }
             else /*IP Version = IPv4 */
                 {
	             flagInner = 6; /*For IP Network = IPv4 validation */
	             }
             }
         else
             {
             if(flag == 2) /* IPV4/IPv6 IP Address*/
                 {
                 if(selIPType == 2) /*IP Version = IPv6 */
                     {
                     flagInner = 4; /*For IP Address = IPv6 validation*/
                     }
                 else /*IP Version = IPv4 */
                     {
		             flagInner = 5; /*For IP Address = IPv4 validation*/
		             }
		         }
		     }
		   }
	else
	    {flagInner = 0;}
		   
    if(flagInner == 1 || flagInner == 6)
        {
        if(ipv4Validate('txtIPAdd', 'IP', false, true, 'Invalid IP address', 'for octet ', true) == false)
            return false;
        if (ipv4Validate('tblWi1IpSnetmask', 'SM', false, true,'Invalid Subnet Mask', 'for octate ', true) == false)
            return false;
        }
    else if(flagInner == 2 || flagInner == 5)
        {
        if(ipv4Validate('txtIPAdd', 'IPD', false, true, 'Invalid IP address', 'for octet ', true) == false)
            return false;
        }
    else if(flagInner == 3)
        {
        if (ipv6Validate ('txtIPAddV6', false, true, '') == false)
	    return false;
        if (numericValueRangeCheck (txtPreLenObj, '', '', 1, 128, true, '', '') == false)
            return false;
        }
    else if(flagInner == 4)
        {
        if (ipv6Validate ('txtIPAddV6', false, true, '') == false)
	    return false;
        }
        
    return true;
    }
    
    
function selIPAddrType ()
    {
	var hdIPmodeObj = document.getElementById('ipModeType');
	if(hdIPmodeObj && hdIPmodeObj == '') return;
	var editFlag = document.getElementById('hdEditFlag').value;
	if(editFlag != 1){
	    if(hdIPmodeObj.value == 3)
	        {        
	        fieldStateChangeWr ('','','selIpv6','');
	        }
	    else
	        {        
	        fieldStateChangeWr ('selIpv6','','','');
	        }
    }	
    }

function onTabCheck 
     (
     objId, /*objId = ip text filed ID*/
     objType, /*objType = type of IP - IP /SM,*/
     error /*error = error message*/
     )
    {
    var errMsg = error;
    var selcIPType = comboSelectedValueGet ('selIPType');
    if(!(document.getElementById('selIPType').disabled) && parseInt(selcIPType, 10) == 2)
        {
        if (ipv6Validate (objId, false, true, '') == false)
	        return false;
        }
    else
        {
        if(ipv4Validate(objId, objType, false, true, errMsg, 'for octet ', true) == false)
            return false;
        }
    return true;    
    }

function applyPolicyInnerFun ()
    {
    selIPAddrType ();
    var selIPTypeObj = document.getElementById('selIPType');
    if(!(selIPTypeObj.disabled))
        {
        var selIPTypeVal = parseInt(document.getElementById('selIPType').value,10);
        if(selIPTypeVal != '' && selIPTypeVal == 2)
            {
            fieldStateChangeWr ('tblWi1IpSnetmask txtIPAdd','','txtIPAddV6 txtPreLenId','');
            }
        else
            {
            fieldStateChangeWr ('txtPreLenId txtIPAddV6','','txtIPAdd tblWi1IpSnetmask','');
            }
        }
    else
        {
        fieldStateChangeWr ('txtPreLenId txtIPAddV6','','txtIPAdd tblWi1IpSnetmask','');
        }
    }
    
/****************************************************************************
Function: toggleWrapper
Purpose: wrapper function, calls other inter related function also
params : N/A
Returns: N/A
*/

function toggleWrapper ()
    {
    selIPAddrType ();
    var radioValue = radioCheckedValueGet ('ipv4_ipv6');
    var addressFamilyObj = document.getElementById ('selIPType'); 
    var editFlagObj = document.getElementById ('hdEditFlag');   
    if( addressFamilyObj && editFlagObj.value != 1)
        {        
        addressFamilyObj.value = radioValue;        
        }     
        
     if (addressFamilyObj.value == "2")
        {            
            toggle ('trIpAddressV4 trSubnet', '', '', 'trIpAddressV6 trPrefixIpv6', 'txtIPAdd tblWi1IpSnetmask', 'trIpAddressV4 trSubnet', 'txtIPAddV6 txtPreLenId', 'trIpAddressV6 trPrefixIpv6');
        }
     else
        {
           toggle ('', 'trIpAddressV6 trPrefixIpv6', 'trIpAddressV4 trSubnet', '', 'txtIPAddV6 txtPreLenId', 'trIpAddressV6 trPrefixIpv6', 'txtIPAdd tblWi1IpSnetmask', 'trIpAddressV4 trSubnet');
        }
     policyTypeCheck ();
     applyPolicyCheck ();
    }
